import Router from 'next/router';
import { ofType } from 'redux-observable';
import { concat, of } from 'rxjs';
import { switchMap } from 'rxjs/operators';

import { GET_CONFIGURATION } from '@/graphql/services/onlineHelp/constants';
import { TYPE_ERROR } from '@/modules/@common/notify/constants';

import { PAYLOAD_NAME } from '@/graphql/services/onlineHelp/types/payload/configuration';

import { getItemAction, setAction } from '../slices';
import { gqlRequest } from '@/modules/@common/request';
import { showNotificationAction } from '@/modules/layout/redux/slices';

const query = `
  query ${GET_CONFIGURATION}($payload: ${PAYLOAD_NAME}) {
    ${GET_CONFIGURATION}(payload: $payload) {
      id
      name
      suffix
      helpPageUrl
    }
  }
`;

const getResponse = ({ data }) => data[GET_CONFIGURATION];

export default (action$) =>
  action$.pipe(
    ofType(getItemAction.type),
    switchMap((action) => {
      const stream$ = gqlRequest(
        {
          query,
          variables: {
            payload: {
              id: action.payload.id,
            },
          },
        },
        {
          showNotificationMessage: false,
        },
      ).pipe(
        switchMap((response) => {
          const actions = [];

          if (response.errors.length) {
            actions.push(
              of(
                showNotificationAction({
                  type: TYPE_ERROR,
                  message: "Can't open configuration for edit",
                }),
              ),
            );

            Router.push('/online-help');
          } else {
            const data = getResponse(response);

            actions.push(
              of(
                setAction({
                  ...data,
                }),
              ),
            );
          }

          return concat(...actions);
        }),
      );

      return concat(stream$);
    }),
  );
